%% This file finds the mean of the interest rate given the equation with
% Markov-switching and the lower bound as described in the paper
%
% Manuel Gonzalez-Astudillo
% 1/9/2017
%% Parameterizing
rbar = 2.57;
rho = 0.88;
alpha1 = 0.73;
alpha2 = 1.62;
sr1 = 0.23;
sr2 = 1.25;
y_ = 0.25;
pii = 2;

pSm = [0.56;0.44];
pSsr = [0.68;0.32];
pjoint = kron(pSsr,pSm);

betta11 = [rbar;rho;alpha1;sr1];
betta21 = [rbar;rho;alpha2;sr1];
betta12 = [rbar;rho;alpha1;sr2];
betta22 = [rbar;rho;alpha2;sr2];

%% Obtaining the mean for each state
param0 = [3;0];

param11 = fsolve(@(param)residmeanr(param, betta11, pii, y_),param0);
meanr11 = param11(1);
varr11 = exp(param11(2));

param21 = fsolve(@(param)residmeanr(param, betta21, pii, y_),param0);
meanr21 = param21(1);
varr21 = exp(param21(2));

param12 = fsolve(@(param)residmeanr(param, betta12, pii, y_),param0);
meanr12 = param12(1);
varr12 = exp(param12(2));

param22 = fsolve(@(param)residmeanr(param, betta22, pii, y_),param0);
meanr22 = param22(1);
varr22 = exp(param22(2));

meanr = pjoint'*[meanr11;meanr21;meanr12;meanr22];



