function vecparam = fun_vec_param(param)
% fun_vec_param: obtains the vector of parameters as evaluated at param
R_1 = exp(param(1));
R_2 = exp(param(2));
alphap_1 = exp(param(3));
alphap_2 = alphap_1 + exp(param(4));
alphay_1 = exp(param(5));
alphay_2 = alphay_1 + param(6);
kappaRp_1 = param(7);
kappaRp_2 = kappaRp_1 + param(8);
kappaRy_1 = param(9);
kappaRy_2 = kappaRy_1 + param(10);
rhoR_1 = exp(param(11))/(1+exp(param(11)));
rhoR_2 = exp(param(12))/(1+exp(param(12)));
sigmaR_1 = exp(param(13));
sigmaR_2 = sigmaR_1 + exp(param(14));
tau_1 = exp(param(15));
tau_2 = exp(param(16));
gammab_1 = param(17);
gammab_2 = gammab_1 + exp(param(18));
gammay_1 = exp(param(19));
gammay_2 = gammay_1 + param(20);
kappatauy_1 = param(21);
kappatauy_2 = kappatauy_1 + param(22);
rhotau_1 = exp(param(23))/(1+exp(param(23)));
rhotau_2 = exp(param(24))/(1+exp(param(24)));
sigmatau_1 = exp(param(25));
sigmatau_2 = sigmatau_1 + exp(param(26));
vecparam = [R_1;R_2;alphap_1;alphay_1;alphap_2;alphay_2;kappaRp_1;kappaRp_2;kappaRy_1;kappaRy_2 ;rhoR_1;rhoR_2;sigmaR_1;sigmaR_2;...
            tau_1;tau_2;gammab_1;gammab_2;gammay_1;gammay_2;kappatauy_1;kappatauy_2;rhotau_1;rhotau_2;sigmatau_1;sigmatau_2];
end

