function loglik = loglikfunfixedrhoint(param,data)

%% Setting up parameters
paramm = param(1:22);
R_c = exp(paramm(1));
alphap_1 = exp(paramm(2));
alphap_2 = alphap_1 + exp(paramm(3));
alphay_1 = exp(paramm(4));
alphay_2 = alphay_1 + paramm(5);
kappaRp_1 = paramm(6);
kappaRp_2 = kappaRp_1 + paramm(7);
kappaRy_1 = paramm(8);
kappaRy_2 = kappaRy_1 + paramm(9);
rhoR = exp(paramm(10))/(1+exp(paramm(10)));
sigmaR_1 = exp(paramm(11));
sigmaR_2 = sigmaR_1 + exp(paramm(12));
tau_c = exp(paramm(13));
gammab_1 = paramm(14);
gammab_2 = gammab_1 + exp(paramm(15));
gammay_1 = exp(paramm(16));
gammay_2 = gammay_1 + paramm(17);
kappatauy_1 = paramm(18);
kappatauy_2 = kappatauy_1 + paramm(19);
rhotau = exp(paramm(20))/(1+exp(paramm(20)));
sigmatau_1 = exp(paramm(21));
sigmatau_2 = sigmatau_1 + exp(paramm(22));

betaR_11 = [rhoR (1-rhoR)*[R_c alphap_1 alphay_1] sigmaR_1*kappaRp_1 sigmaR_1*kappaRy_1]';
betaR_12 = [rhoR (1-rhoR)*[R_c alphap_1 alphay_1] sigmaR_2*kappaRp_1 sigmaR_2*kappaRy_1]';
betaR_21 = [rhoR (1-rhoR)*[R_c alphap_2 alphay_2] sigmaR_1*kappaRp_2 sigmaR_1*kappaRy_2]';
betaR_22 = [rhoR (1-rhoR)*[R_c alphap_2 alphay_2] sigmaR_2*kappaRp_2 sigmaR_2*kappaRy_2]';
betatau_11 = [rhotau (1-rhotau)*[tau_c gammab_1 gammay_1] sigmatau_1*kappatauy_1]';
betatau_12 = [rhotau (1-rhotau)*[tau_c gammab_1 gammay_1] sigmatau_2*kappatauy_1]';
betatau_21 = [rhotau (1-rhotau)*[tau_c gammab_2 gammay_2] sigmatau_1*kappatauy_2]';
betatau_22 = [rhotau (1-rhotau)*[tau_c gammab_2 gammay_2] sigmatau_2*kappatauy_2]';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Smf
% jmf = 1 <-- jm = 1, jf = 1;
% jmf = 2 <-- jm = 2, jf = 1;
% jmf = 3 <-- jm = 1, jf = 2;
% jmf = 4 <-- jm = 2, jf = 2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
paramp = param(23:38);
pmf_11 = exp(paramp(1))/(1+exp(paramp(1))+exp(paramp(2))+exp(paramp(3)));
pmf_21 = exp(paramp(2))/(1+exp(paramp(1))+exp(paramp(2))+exp(paramp(3)));
pmf_31 = exp(paramp(3))/(1+exp(paramp(1))+exp(paramp(2))+exp(paramp(3)));
pmf_41 = 1/(1+exp(paramp(1))+exp(paramp(2))+exp(paramp(3)));
pmf_12 = exp(paramp(4))/(1+exp(paramp(4))+exp(paramp(5))+exp(paramp(6)));
pmf_22 = exp(paramp(5))/(1+exp(paramp(4))+exp(paramp(5))+exp(paramp(6)));
pmf_32 = exp(paramp(6))/(1+exp(paramp(4))+exp(paramp(5))+exp(paramp(6)));
pmf_42 = 1/(1+exp(paramp(4))+exp(paramp(5))+exp(paramp(6)));
pmf_13 = exp(paramp(7))/(1+exp(paramp(7))+exp(paramp(8))+exp(paramp(9)));
pmf_23 = exp(paramp(8))/(1+exp(paramp(7))+exp(paramp(8))+exp(paramp(9)));
pmf_33 = exp(paramp(9))/(1+exp(paramp(7))+exp(paramp(8))+exp(paramp(9)));
pmf_43 = 1/(1+exp(paramp(7))+exp(paramp(8))+exp(paramp(9)));
pmf_14 = exp(paramp(10))/(1+exp(paramp(10))+exp(paramp(11))+exp(paramp(12)));
pmf_24 = exp(paramp(11))/(1+exp(paramp(10))+exp(paramp(11))+exp(paramp(12)));
pmf_34 = exp(paramp(12))/(1+exp(paramp(10))+exp(paramp(11))+exp(paramp(12)));
pmf_44 = 1/(1+exp(paramp(10))+exp(paramp(11))+exp(paramp(12)));

PSmf = [pmf_11 pmf_12 pmf_13 pmf_14;
        pmf_21 pmf_22 pmf_23 pmf_24;
        pmf_31 pmf_32 pmf_33 pmf_34;
        pmf_41 pmf_42 pmf_43 pmf_44];

% Transition Probabilities for standard deviation of R
psR_11 = exp(paramp(13))/(1+exp(paramp(13)));
psR_21 = 1/(1+exp(paramp(13)));
psR_12 = exp(paramp(14))/(1+exp(paramp(14)));
psR_22 = 1/(1+exp(paramp(14)));

PsR = [psR_11 psR_12;
       psR_21 psR_22];
   
% Transition Probabilities for standard deviation of tau
pstau_11 = exp(paramp(15))/(1+exp(paramp(15)));
pstau_21 = 1/(1+exp(paramp(15)));
pstau_12 = exp(paramp(16))/(1+exp(paramp(16)));
pstau_22 = 1/(1+exp(paramp(16)));

Pstau = [pstau_11 pstau_12;
         pstau_21 pstau_22];
   
% Global Transition Probability Matrix
P = kron(Pstau,kron(PsR,PSmf));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [ pmf_11*psR_11*pstau_11, pmf_12*psR_11*pstau_11, pmf_13*psR_11*pstau_11, pmf_14*psR_11*pstau_11, pmf_11*psR_12*pstau_11, pmf_12*psR_12*pstau_11, pmf_13*psR_12*pstau_11, pmf_14*psR_12*pstau_11, pmf_11*psR_11*pstau_12, pmf_12*psR_11*pstau_12, pmf_13*psR_11*pstau_12, pmf_14*psR_11*pstau_12, pmf_11*psR_12*pstau_12, pmf_12*psR_12*pstau_12, pmf_13*psR_12*pstau_12, pmf_14*psR_12*pstau_12]
% [ pmf_21*psR_11*pstau_11, pmf_22*psR_11*pstau_11, pmf_23*psR_11*pstau_11, pmf_24*psR_11*pstau_11, pmf_21*psR_12*pstau_11, pmf_22*psR_12*pstau_11, pmf_23*psR_12*pstau_11, pmf_24*psR_12*pstau_11, pmf_21*psR_11*pstau_12, pmf_22*psR_11*pstau_12, pmf_23*psR_11*pstau_12, pmf_24*psR_11*pstau_12, pmf_21*psR_12*pstau_12, pmf_22*psR_12*pstau_12, pmf_23*psR_12*pstau_12, pmf_24*psR_12*pstau_12]
% [ pmf_31*psR_11*pstau_11, pmf_32*psR_11*pstau_11, pmf_33*psR_11*pstau_11, pmf_34*psR_11*pstau_11, pmf_31*psR_12*pstau_11, pmf_32*psR_12*pstau_11, pmf_33*psR_12*pstau_11, pmf_34*psR_12*pstau_11, pmf_31*psR_11*pstau_12, pmf_32*psR_11*pstau_12, pmf_33*psR_11*pstau_12, pmf_34*psR_11*pstau_12, pmf_31*psR_12*pstau_12, pmf_32*psR_12*pstau_12, pmf_33*psR_12*pstau_12, pmf_34*psR_12*pstau_12]
% [ pmf_41*psR_11*pstau_11, pmf_42*psR_11*pstau_11, pmf_43*psR_11*pstau_11, pmf_44*psR_11*pstau_11, pmf_41*psR_12*pstau_11, pmf_42*psR_12*pstau_11, pmf_43*psR_12*pstau_11, pmf_44*psR_12*pstau_11, pmf_41*psR_11*pstau_12, pmf_42*psR_11*pstau_12, pmf_43*psR_11*pstau_12, pmf_44*psR_11*pstau_12, pmf_41*psR_12*pstau_12, pmf_42*psR_12*pstau_12, pmf_43*psR_12*pstau_12, pmf_44*psR_12*pstau_12]
% [ pmf_11*psR_21*pstau_11, pmf_12*psR_21*pstau_11, pmf_13*psR_21*pstau_11, pmf_14*psR_21*pstau_11, pmf_11*psR_22*pstau_11, pmf_12*psR_22*pstau_11, pmf_13*psR_22*pstau_11, pmf_14*psR_22*pstau_11, pmf_11*psR_21*pstau_12, pmf_12*psR_21*pstau_12, pmf_13*psR_21*pstau_12, pmf_14*psR_21*pstau_12, pmf_11*psR_22*pstau_12, pmf_12*psR_22*pstau_12, pmf_13*psR_22*pstau_12, pmf_14*psR_22*pstau_12]
% [ pmf_21*psR_21*pstau_11, pmf_22*psR_21*pstau_11, pmf_23*psR_21*pstau_11, pmf_24*psR_21*pstau_11, pmf_21*psR_22*pstau_11, pmf_22*psR_22*pstau_11, pmf_23*psR_22*pstau_11, pmf_24*psR_22*pstau_11, pmf_21*psR_21*pstau_12, pmf_22*psR_21*pstau_12, pmf_23*psR_21*pstau_12, pmf_24*psR_21*pstau_12, pmf_21*psR_22*pstau_12, pmf_22*psR_22*pstau_12, pmf_23*psR_22*pstau_12, pmf_24*psR_22*pstau_12]
% [ pmf_31*psR_21*pstau_11, pmf_32*psR_21*pstau_11, pmf_33*psR_21*pstau_11, pmf_34*psR_21*pstau_11, pmf_31*psR_22*pstau_11, pmf_32*psR_22*pstau_11, pmf_33*psR_22*pstau_11, pmf_34*psR_22*pstau_11, pmf_31*psR_21*pstau_12, pmf_32*psR_21*pstau_12, pmf_33*psR_21*pstau_12, pmf_34*psR_21*pstau_12, pmf_31*psR_22*pstau_12, pmf_32*psR_22*pstau_12, pmf_33*psR_22*pstau_12, pmf_34*psR_22*pstau_12]
% [ pmf_41*psR_21*pstau_11, pmf_42*psR_21*pstau_11, pmf_43*psR_21*pstau_11, pmf_44*psR_21*pstau_11, pmf_41*psR_22*pstau_11, pmf_42*psR_22*pstau_11, pmf_43*psR_22*pstau_11, pmf_44*psR_22*pstau_11, pmf_41*psR_21*pstau_12, pmf_42*psR_21*pstau_12, pmf_43*psR_21*pstau_12, pmf_44*psR_21*pstau_12, pmf_41*psR_22*pstau_12, pmf_42*psR_22*pstau_12, pmf_43*psR_22*pstau_12, pmf_44*psR_22*pstau_12]
% [ pmf_11*psR_11*pstau_21, pmf_12*psR_11*pstau_21, pmf_13*psR_11*pstau_21, pmf_14*psR_11*pstau_21, pmf_11*psR_12*pstau_21, pmf_12*psR_12*pstau_21, pmf_13*psR_12*pstau_21, pmf_14*psR_12*pstau_21, pmf_11*psR_11*pstau_22, pmf_12*psR_11*pstau_22, pmf_13*psR_11*pstau_22, pmf_14*psR_11*pstau_22, pmf_11*psR_12*pstau_22, pmf_12*psR_12*pstau_22, pmf_13*psR_12*pstau_22, pmf_14*psR_12*pstau_22]
% [ pmf_21*psR_11*pstau_21, pmf_22*psR_11*pstau_21, pmf_23*psR_11*pstau_21, pmf_24*psR_11*pstau_21, pmf_21*psR_12*pstau_21, pmf_22*psR_12*pstau_21, pmf_23*psR_12*pstau_21, pmf_24*psR_12*pstau_21, pmf_21*psR_11*pstau_22, pmf_22*psR_11*pstau_22, pmf_23*psR_11*pstau_22, pmf_24*psR_11*pstau_22, pmf_21*psR_12*pstau_22, pmf_22*psR_12*pstau_22, pmf_23*psR_12*pstau_22, pmf_24*psR_12*pstau_22]
% [ pmf_31*psR_11*pstau_21, pmf_32*psR_11*pstau_21, pmf_33*psR_11*pstau_21, pmf_34*psR_11*pstau_21, pmf_31*psR_12*pstau_21, pmf_32*psR_12*pstau_21, pmf_33*psR_12*pstau_21, pmf_34*psR_12*pstau_21, pmf_31*psR_11*pstau_22, pmf_32*psR_11*pstau_22, pmf_33*psR_11*pstau_22, pmf_34*psR_11*pstau_22, pmf_31*psR_12*pstau_22, pmf_32*psR_12*pstau_22, pmf_33*psR_12*pstau_22, pmf_34*psR_12*pstau_22]
% [ pmf_41*psR_11*pstau_21, pmf_42*psR_11*pstau_21, pmf_43*psR_11*pstau_21, pmf_44*psR_11*pstau_21, pmf_41*psR_12*pstau_21, pmf_42*psR_12*pstau_21, pmf_43*psR_12*pstau_21, pmf_44*psR_12*pstau_21, pmf_41*psR_11*pstau_22, pmf_42*psR_11*pstau_22, pmf_43*psR_11*pstau_22, pmf_44*psR_11*pstau_22, pmf_41*psR_12*pstau_22, pmf_42*psR_12*pstau_22, pmf_43*psR_12*pstau_22, pmf_44*psR_12*pstau_22]
% [ pmf_11*psR_21*pstau_21, pmf_12*psR_21*pstau_21, pmf_13*psR_21*pstau_21, pmf_14*psR_21*pstau_21, pmf_11*psR_22*pstau_21, pmf_12*psR_22*pstau_21, pmf_13*psR_22*pstau_21, pmf_14*psR_22*pstau_21, pmf_11*psR_21*pstau_22, pmf_12*psR_21*pstau_22, pmf_13*psR_21*pstau_22, pmf_14*psR_21*pstau_22, pmf_11*psR_22*pstau_22, pmf_12*psR_22*pstau_22, pmf_13*psR_22*pstau_22, pmf_14*psR_22*pstau_22]
% [ pmf_21*psR_21*pstau_21, pmf_22*psR_21*pstau_21, pmf_23*psR_21*pstau_21, pmf_24*psR_21*pstau_21, pmf_21*psR_22*pstau_21, pmf_22*psR_22*pstau_21, pmf_23*psR_22*pstau_21, pmf_24*psR_22*pstau_21, pmf_21*psR_21*pstau_22, pmf_22*psR_21*pstau_22, pmf_23*psR_21*pstau_22, pmf_24*psR_21*pstau_22, pmf_21*psR_22*pstau_22, pmf_22*psR_22*pstau_22, pmf_23*psR_22*pstau_22, pmf_24*psR_22*pstau_22]
% [ pmf_31*psR_21*pstau_21, pmf_32*psR_21*pstau_21, pmf_33*psR_21*pstau_21, pmf_34*psR_21*pstau_21, pmf_31*psR_22*pstau_21, pmf_32*psR_22*pstau_21, pmf_33*psR_22*pstau_21, pmf_34*psR_22*pstau_21, pmf_31*psR_21*pstau_22, pmf_32*psR_21*pstau_22, pmf_33*psR_21*pstau_22, pmf_34*psR_21*pstau_22, pmf_31*psR_22*pstau_22, pmf_32*psR_22*pstau_22, pmf_33*psR_22*pstau_22, pmf_34*psR_22*pstau_22]
% [ pmf_41*psR_21*pstau_21, pmf_42*psR_21*pstau_21, pmf_43*psR_21*pstau_21, pmf_44*psR_21*pstau_21, pmf_41*psR_22*pstau_21, pmf_42*psR_22*pstau_21, pmf_43*psR_22*pstau_21, pmf_44*psR_22*pstau_21, pmf_41*psR_21*pstau_22, pmf_42*psR_21*pstau_22, pmf_43*psR_21*pstau_22, pmf_44*psR_21*pstau_22, pmf_41*psR_22*pstau_22, pmf_42*psR_22*pstau_22, pmf_43*psR_22*pstau_22, pmf_44*psR_22*pstau_22]

% S
% j = 1 <-- jmf = 1 (jm = 1, jf = 1), jsR = 1, jstau = 1
% j = 2 <-- jmf = 2 (jm = 2, jf = 1), jsR = 1, jstau = 1
% j = 3 <-- jmf = 3 (jm = 1, jf = 2), jsR = 1, jstau = 1
% j = 4 <-- jmf = 4 (jm = 2, jf = 2), jsR = 1, jstau = 1
% j = 5 <-- jmf = 1 (jm = 1, jf = 1), jsR = 2, jstau = 1
% j = 6 <-- jmf = 2 (jm = 2, jf = 1), jsR = 2, jstau = 1
% j = 7 <-- jmf = 3 (jm = 1, jf = 2), jsR = 2, jstau = 1
% j = 8 <-- jmf = 4 (jm = 2, jf = 2), jsR = 2, jstau = 1
% j = 9 <-- jmf = 1 (jm = 1, jf = 1), jsR = 1, jstau = 2
% j = 10 <-- jmf = 2 (jm = 2, jf = 1), jsR = 1, jstau = 2
% j = 11 <-- jmf = 3 (jm = 1, jf = 2), jsR = 1, jstau = 2
% j = 12 <-- jmf = 4 (jm = 2, jf = 2), jsR = 1, jstau = 2
% j = 13 <-- jmf = 1 (jm = 1, jf = 1), jsR = 2, jstau = 2
% j = 14 <-- jmf = 2 (jm = 2, jf = 1), jsR = 2, jstau = 2
% j = 15 <-- jmf = 3 (jm = 1, jf = 2), jsR = 2, jstau = 2
% j = 16 <-- jmf = 4 (jm = 2, jf = 2), jsR = 2, jstau = 2

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
A = [eye(16)-P;ones(1,16)];
p_ = (A'*A)\A';
p = p_(:,17); % unconditional probabilities vector

T = size(data,1);
%% Setting up data
% data = [R_t tau_t p_t y_t b_{t-1} v_p v_y]
R = data(2:T,1);
dzlb = (R==0.25); % Dummy ZLB
tau = data(2:T,2);
xR = [data(1:T-1,1) ones(T-1,1) data(2:T,3:4) data(2:T,6:7)];
xtau = [data(1:T-1,2) ones(T-1,1) data(2:T,5) data(2:T,4) data(2:T,7)];

%% Obtaining log-likelihood function
pred_p_1 = p(1); % initial filter probability
pred_p_2 = p(2); % initial filter probability
pred_p_3 = p(3); % initial filter probability
pred_p_4 = p(4); % initial filter probability
pred_p_5 = p(5); % initial filter probability
pred_p_6 = p(6); % initial filter probability
pred_p_7 = p(7); % initial filter probability
pred_p_8 = p(8); % initial filter probability
pred_p_9 = p(9); % initial filter probability
pred_p_10 = p(10); % initial filter probability
pred_p_11 = p(11); % initial filter probability
pred_p_12 = p(12); % initial filter probability
pred_p_13 = p(13); % initial filter probability
pred_p_14 = p(14); % initial filter probability
pred_p_15 = p(15); % initial filter probability
pred_p_16 = p(16); % initial filter probability

% Densities conditional on state
fR11 = ((normpdf(R,xR*betaR_11,sigmaR_1)).^(1-dzlb)).*((1-normcdf(xR*betaR_11-0.25,0,sigmaR_1)).^dzlb); % density for R conditional on betaR_1 and sigma_1
fR21 = ((normpdf(R,xR*betaR_21,sigmaR_1)).^(1-dzlb)).*((1-normcdf(xR*betaR_21-0.25,0,sigmaR_1)).^dzlb); % density for R conditional on betaR_1 and sigma_2
fR12 = ((normpdf(R,xR*betaR_12,sigmaR_2)).^(1-dzlb)).*((1-normcdf(xR*betaR_12-0.25,0,sigmaR_2)).^dzlb); % density for R conditional on betaR_2 and sigma_1
fR22 = ((normpdf(R,xR*betaR_22,sigmaR_2)).^(1-dzlb)).*((1-normcdf(xR*betaR_22-0.25,0,sigmaR_2)).^dzlb); % density for R conditional on betaR_2 and sigma_2
ftau11 = normpdf(tau,xtau*betatau_11,sigmatau_1); % density for tau conditional on betatau_1 sigmatau_1
ftau21 = normpdf(tau,xtau*betatau_21,sigmatau_1); % density for tau conditional on betatau_2 sigmatau_1
ftau12 = normpdf(tau,xtau*betatau_12,sigmatau_2); % density for tau conditional on betatau_1 sigmatau_2
ftau22 = normpdf(tau,xtau*betatau_22,sigmatau_2); % density for tau conditional on betatau_2 sigmatau_2

loglik = 0;
for t = 1:T-1
    fy = pred_p_1*fR11(t)*ftau11(t) + pred_p_2*fR21(t)*ftau11(t) + pred_p_3*fR11(t)*ftau21(t) + pred_p_4*fR21(t)*ftau21(t) +...
         pred_p_5*fR12(t)*ftau11(t) + pred_p_6*fR22(t)*ftau11(t) + pred_p_7*fR12(t)*ftau21(t) + pred_p_8*fR22(t)*ftau21(t) +...
         pred_p_9*fR11(t)*ftau12(t) + pred_p_10*fR21(t)*ftau12(t) + pred_p_11*fR11(t)*ftau22(t) + pred_p_12*fR21(t)*ftau22(t) +...
         pred_p_13*fR12(t)*ftau12(t) + pred_p_14*fR22(t)*ftau12(t) + pred_p_15*fR12(t)*ftau22(t) + pred_p_16*fR22(t)*ftau22(t); % joint density integrated over states
    loglik = loglik + log(fy); % log-likelihood
    %Update step
    filter_p_1 = pred_p_1*fR11(t)*ftau11(t)/fy; % filtered probability state 1
    filter_p_2 = pred_p_2*fR21(t)*ftau11(t)/fy; % filtered probability state 2
    filter_p_3 = pred_p_3*fR11(t)*ftau21(t)/fy; % filtered probability state 3
    filter_p_4 = pred_p_4*fR21(t)*ftau21(t)/fy; % filtered probability state 4
    filter_p_5 = pred_p_5*fR12(t)*ftau11(t)/fy; % filtered probability state 5
    filter_p_6 = pred_p_6*fR22(t)*ftau11(t)/fy; % filtered probability state 6
    filter_p_7 = pred_p_7*fR12(t)*ftau21(t)/fy; % filtered probability state 7
    filter_p_8 = pred_p_8*fR22(t)*ftau21(t)/fy; % filtered probability state 8
    filter_p_9 = pred_p_9*fR11(t)*ftau12(t)/fy; % filtered probability state 9
    filter_p_10 = pred_p_10*fR21(t)*ftau12(t)/fy; % filtered probability state 10
    filter_p_11 = pred_p_11*fR11(t)*ftau22(t)/fy; % filtered probability state 11
    filter_p_12 = pred_p_12*fR21(t)*ftau22(t)/fy; % filtered probability state 12
    filter_p_13 = pred_p_13*fR12(t)*ftau12(t)/fy; % filtered probability state 13
    filter_p_14 = pred_p_14*fR22(t)*ftau12(t)/fy; % filtered probability state 14
    filter_p_15 = pred_p_15*fR12(t)*ftau22(t)/fy; % filtered probability state 15
    filter_p_16 = pred_p_16*fR22(t)*ftau22(t)/fy; % filtered probability state 16
    %Prediction step
    filter_p = [filter_p_1;filter_p_2;filter_p_3;filter_p_4;...
                filter_p_5;filter_p_6;filter_p_7;filter_p_8;...
                filter_p_9;filter_p_10;filter_p_11;filter_p_12;...
                filter_p_13;filter_p_14;filter_p_15;filter_p_16];
    pred_p_1 = P(1,:)*filter_p; % prediction probability state 1
    pred_p_2 = P(2,:)*filter_p; % prediction probability state 2
    pred_p_3 = P(3,:)*filter_p; % prediction probability state 3
    pred_p_4 = P(4,:)*filter_p; % prediction probability state 4
    pred_p_5 = P(5,:)*filter_p; % prediction probability state 5
    pred_p_6 = P(6,:)*filter_p; % prediction probability state 6
    pred_p_7 = P(7,:)*filter_p; % prediction probability state 7
    pred_p_8 = P(8,:)*filter_p; % prediction probability state 8
    pred_p_9 = P(9,:)*filter_p; % prediction probability state 9
    pred_p_10 = P(10,:)*filter_p; % prediction probability state 10
    pred_p_11 = P(11,:)*filter_p; % prediction probability state 11
    pred_p_12 = P(12,:)*filter_p; % prediction probability state 12
    pred_p_13 = P(13,:)*filter_p; % prediction probability state 13
    pred_p_14 = P(14,:)*filter_p; % prediction probability state 14
    pred_p_15 = P(15,:)*filter_p; % prediction probability state 15
    pred_p_16 = P(16,:)*filter_p; % prediction probability state 16
end;

loglik = -loglik;
